# Terms of Service

Last revised on 2021-10-18

## Summary

@lexicalunit operates an instance of SpellBot, which we hope you use. If you use it, please use it responsibly. If you don't, we'll have to ban your account.

The Terms of Service and SpellBot itself can change at any time. We'll try to warn you about major changes to the Terms of Service or SpellBot, but we make no guarantees.

That's the basic idea, but You must read through the entire Terms of Service below and agree with all the details before You use SpellBot.

## Reuse

This document is an adaptation of the [Heroku Terms of Service](http://legal.heroku.com/tos), which is turn an adaptation of the [Google App Engine Terms of Service](http://code.google.com/appengine/terms.html). The original work has been modified with permission under the [Creative Commons Attribution 3.0 License](http://creativecommons.org/licenses/by/3.0/). Neither Heroku, Inc. nor Google, Inc. is not connected with and does not sponsor or endorse SpellBot or its use of the work.

You're welcome to adapt and use this document for your own needs. If you make an improvement, we'd appreciate it if you would let us know so we can consider improving our own document.

## Your Agreement with SpellBot

Your use of the SpellBot service is governed by this agreement (the "Terms"). The "Service" means the SpellBot instance that @lexicalunit operates and makes available to be invited to Discord servers. "Content" means all content generated by SpellBot on your behalf (including metric data).

In order to use the Service, You (the "Customer", "You", or "Your") must first agree to the Terms. You understand and agree that SpellBot will treat Your use of the Service as acceptance of the Terms from that point onwards.

SpellBot may make changes to the Terms from time to time. You may reject the changes by ceasing to use Spellbot. You understand and agree that if You use the Service after the date on which the Terms have changed, SpellBot will treat Your use as acceptance of the updated Terms.

If you have any question about the Terms, please contact us at spellbot@lexicalunit.com.

## Your Account

- You may not use the Service if You are a person barred from receiving the Service under the laws of the United States or other countries, including the country in which You are resident or from which You use the Service.
- You must be a human. Account created by automated methods are not permitted.

## Use of the Service

- Your use of the Service must comply with all applicable laws, regulations and ordinances.
- You agree to not engage in any activity that interferes with or disrupts the Service.
- SpellBot reserves the right to enforce quotas and usage limits (to any resources, including the API) at its sole discretion, with or without notice, which may result in SpellBot disabling or throttling your usage of the Service for any amount of time.
- You may not allow multiple people to use the same account or otherwise access the Service in a manner intended to avoid incurring fees.

## Service Policies and Privacy

The Service shall be subject to the privacy policy for the Service available at privacy policy. You agree to the use of Your data in accordance with SpellBot's privacy policies.

## Fees for Use of the Service

The Service may be provided to You without charge.

## Cancellation and Termination

- You must cancel Your account by contacting the administrator via spellbot@lexicalunit.com.
- All Content will, within a reasonable amount of time to be determined solely by SpellBot, be deleted from the Service upon cancellation.
- You agree that SpellBot, in its sole discretion and for any or no reason, may terminate or suspend Your account. You agree that any termination of Your access to the Service may be without prior notice, and You agree that SpellBot will not be liable to You or any third party for such termination.

## Ideas and Feedback

You may choose to or we may invite You to submit comments or ideas about the Service, including but not limited to ideas about improving the Service ("Ideas"). By submitting any Idea, You agree that Your disclosure is unsolicited and without restriction and will not place SpellBot under any fiduciary or other obligation, and that we are free to use the Idea without any additional compensation to You, and/or to disclose the Idea on a non-confidential basis or otherwise to anyone.

## Modification of the Service

- You acknowledge and agree that the Service may change from time to time without prior notice to You.
- Changes include, without limitation, changes to fee and payment policies, security patches, added or removed functionality, and other enhancements or restrictions.
- SpellBot shall not be liable to you or to any third party for any modification, price change, suspension or discontinuance of the Service.

## External Resources

The Services may include hyperlinks to other web sites or content or resources or email content. You acknowledge and agree that SpellBot is not responsible for the availability of any such external sites or resources, and does not endorse any advertising, products or other materials on or available from such web sites or resources.

## License from SpellBot and Restrictions

SpellBot gives You a personal, worldwide, royalty-free, non-assignable and non-exclusive license to use the software provided to You by SpellBot as part of the Service as provided to You by SpellBot. This license is for the sole purpose of enabling You to use and enjoy the benefit of the Service as provided by SpellBot, in the manner permitted by the Terms.

You may not (and You may not permit anyone else to): (a) copy, modify, create a derivative work of, reverse engineer, decompile or otherwise attempt to extract the source code of the Service or any part thereof, unless this is expressly permitted or required by law, or unless You have been specifically told that You may do so by SpellBot, in writing (e.g., through an open source software license); or (b) attempt to disable or circumvent any security mechanisms used by the Service.

Open source software licenses for components of the Service released under an open source license constitute separate written agreements. To the limited extent that the open source software licenses expressly supersede these Terms, the open source licenses govern Your agreement with SpellBot for the use of the components of the Service released under an open source license.

## Exclusion of warranties

- You expressly understand and agree that your use of the service is at your sole risk and that the service is provided "as is" and "as available.".
- You agree that SpellBot has no responsibility or liability for the deletion or failure to store any Content and other communications maintained or transmitted through use of the Service. You further acknowledge that You are solely responsible for securing and backing up Customer Source Code.
- SpellBot does not warrant to you that: (a) your use of the service will meet your requirements, (b) your use of the service will be uninterrupted, timely, secure or free from error, (c) the results or data provided by the Service will be accurate, (d) the quality of the service will meet your expectations and (e) any errors in the Service will be fixed.

## Limitation of liability

You expressly understand and agree that SpellBot and its administrators shall not be liable to you for any direct, indirect, incidental, special consequential or exemplary damages which may be incurred by you, however caused and under any theory of liability. This shall include, but not be limited to, any loss of profit (whether incurred directly or indirectly), any loss of goodwill or business reputation, any loss of data suffered, cost of procurement of substitute goods or services, or other intangible loss (whether or not SpellBot has been advised of or should have been aware of the possibility of any such losses arising).

## Indemnification

You agree to hold harmless and indemnify SpellBot, and its administrators, affiliates, officers, agents, employees, advertisers, licensors, suppliers or partners (collectively "SpellBot and Partners") from and against any third party claim arising from or in any way related to (a) Your breach of the Terms, (b) Your use of the Service, or (c) Your violation of applicable laws, rules or regulations in connection with the Service, including any liability or expense arising from all claims, losses, damages (actual and consequential), suits, judgments, litigation costs and attorneys' fees, of every kind and nature. In such a case, SpellBot will provide You with written notice of such claim, suit or action.

## General Legal Terms

The Terms constitute the whole legal agreement between You and SpellBot and govern Your use of the Service and completely replace any prior agreements between You and SpellBot in relation to the Service.

You agree that if SpellBot does not exercise or enforce any legal right or remedy which is contained in the Terms (or which SpellBot has the benefit of under any applicable law), this will not be taken to be a formal waiver of SpellBot's rights and that those rights or remedies will still be available to SpellBot.

SpellBot shall not be liable for failing or delaying performance of its obligations resulting from any condition beyond its reasonable control, including but not limited to, governmental action, acts of terrorism, earthquake, fire, flood or other acts of nature, labor conditions, power failures, and Internet disturbances.
